require(lubridate)
require(XML)
require(ggplot2)
require(reshape2)
require(stringr)
library(foreach)
library(doParallel)

source("issuecomp-functions.R")


load(file = "tweets_untagged.RData")

# Create date range
date_start <- as.Date("2014-01-01")
date_end <- as.Date("2014-12-31")
drange <- as.integer(date_end - date_start)
drange <- date_start + days(0:drange)


# MATCH TWEETS ------------------------------------------------------------

id_folder <- "matched-ids"
unlink(id_folder, recursive = TRUE)
dir.create(id_folder)

issues <- data.frame(date = drange)
issuelist <- readLines("issues.xml")
issuelist <- str_replace_all(string = issuelist, pattern = ".*<!-- .+ -->", "")
issuelist <- xmlToList(issuelist)
issueheads <- names(issuelist)
issues[issueheads] <- 0
tweets$issue <- ""
tweets$tags <- ""

tagexpand <- c("", "s", "n", "en", "er")

# Parallelisation
writeLines(c(""), "issuecomp-analysis.log")  
cl<-makeCluster(3)
registerDoParallel(cl)

df<-foreach(d = 1:3, .packages = c("stringr"), .combine=rbind) %dopar% {
#df<-foreach(d = 1:nrow(issues), .packages = c("stringr"), .combine=rbind) %dopar% {
#for(d in 1:nrow(issues)) {
  # Go through every day
  curdate <- issues$date[d]
  cat(paste(as.character(curdate),"\n"), file="issuecomp-analysis.log", append=TRUE)
  
  # Put all tweets from specific day in a temporary DF
  tweets_curday <- tweets[tweets[, "created_at"] == curdate, ]
  
  for(t in 1:25){
  #for(t in 1:nrow(tweets_curday)){
    cat(paste("Starting tweet", t, "of",as.character(curdate),"\n"), file="issuecomp-analysis.log", append=TRUE)
    # Select tweet's text, make it lowercase and remove hashtag indicators (#)
    curtext <- as.character(tweets_curday$text[t])
    curtext <- str_replace_all(curtext, "#", "")
    
    curid <- as.character(tweets_curday$id_str[t])
    
    # Now test each single issue (not tag!)
    for(i in 1:length(issueheads)) {
      curissue <- issueheads[i]
      curtags <- as.character(issuelist[[curissue]])  
      curfile <- str_c(id_folder,"/",curissue,".csv")

      # Now test all tags of a single issue
      for(s in 1:length(curtags)) {
        curtag <- curtags[s]
        curchars <- nchar(curtag, type = "chars")
        
        # Check if tag is an acronym. If so, ignore.case will be deactivated in smartPatternMatch
        if(curchars <= 4) {
          curacro <- checkAcronym(string = curtag, chars = curchars)
        } else {
          curacro <- FALSE
        }
        
        # Now expand the current tag by possible suffixes that may be plural forms
        if(!curacro) {
          for(e in 1:length(tagexpand)) {
            curtag[e] <- str_c(curtag[1], tagexpand[e])
          }
        }
        
        # Set Levenshtein distance depending on char length
        if(curchars <= 4) {
          curdistance <- 0
        } else {
          curdistance <- 1
        }
                 
        # Match current tweet with tag. If >= 5 letters allow 1 changed letter, if >=8 letters allow also 1 (Levenshtein distance)
        tags_found <- NULL
        # Match the tweet with each variation of tagexpand
        for(e in 1:length(curtag)) {
          tags_found[e] <- smartPatternMatch(curtext, curtag[e], curdistance, curacro)
        }
        tags_found <- any(tags_found)
        curtag <- curtag[1]
        
        if(tags_found == TRUE) {
          # Raise number of findings on this day for this issue by 1
          issues[d,curissue] <- issues[d,curissue] + 1
          
          # Add issue and first matched tag of tweet to tweets-DF
          oldissue <- tweets[tweets[, "id_str"] == curid, "issue"]
          tweets[tweets[, "id_str"] == curid, "issue"] <- str_c(oldissue, curissue, ";")
          oldtag <- tweets[tweets[, "id_str"] == curid, "tags"]
          tweets[tweets[, "id_str"] == curid, "tags"] <- str_c(oldtag, curtag, ";")
          
          # Add information to file for function viewPatternMatching
          write(str_c(curdate,";\"",curid,"\";",curtag), curfile, append = TRUE)
          cat(paste("Match!\n"), file="issuecomp-analysis.log", append=TRUE)
          break
        }
        else {
          #cat("Nothing found\n")
        }
      } # /for curtags
      
    } # /for issuelist
  } # /for tweets_curday
} # /for drange

#rm(tweets_curday,curacro, curchars, curdate,curfile,curid,curissue,curtag,curtags,curtext,d,date_end,date_start,i,id_folder,oldissue,oldtag,s,t,tags_found)
stopCluster(cl)

# SAVING ------------------------------------------------------------------


row.names(tweets) <- NULL
write.csv(tweets, "tweets.csv")
save(tweets, file="tweets.RData")



# SOME TESTS --------------------------------------------------------------

stats <- data.frame(date=drange)
stats$tpd <- 0

# Total number of tweets per day over time
for(r in 1:length(drange)) {
  stats$tpd[r] <- length(tweets[tweets[, "created_at"] == drange[r], "id_str"])
}

stats_melt <- melt(stats, id="date")
g1 <- ggplot(data = stats_melt, aes(x=date,y=value,colour=variable, group=variable)) + 
  geom_line() + 
  geom_smooth(size=1,formula = y ~ x, method="loess", se=FALSE, color=1)
g1

rm(g1, r)


# Show party percentage of twitter users
acc_parties <- data.frame(party = c("cducsu", "spd", "linke", "gruene"))
acc_parties$btw13 <- c(49.3, 30.6, 10.1, 10.0) # seats of party / 631 seats
acc_parties$twitter <- 0
for(p in 1:nrow(acc_parties)) {
  acc_parties$twitter[p] <- round(nrow(acc_df[acc_df$party == as.character(acc_parties$party[p]), ]) / 280 * 100)
}
pie(acc_parties$btw13, col=c("black", "red", "purple", "green"), labels = c("CDU/CSU", "SPD", "Die LINKE", "Bündnis 90/Grüne"), clockwise = T,
    main = "Seats of parties in the parliament")
pie(acc_parties$twitter, col=c("black", "red", "purple", "green"), labels = c("CDU/CSU", "SPD", "Die LINKE", "Bündnis 90/Grüne"), clockwise = T,
    main = "Percentage of parties' MdBs of all Twitter accounts")

rm(acc_parties, p)


# VISUALS -----------------------------------------------------------------


# Level: days
issues_melt <- melt(issues,id="date")
ggplot(issues_melt,aes(x=date,y=value,colour=variable,group=variable)) + geom_line(size=1)
ggplot(issues_melt,aes(x=date,y=value,colour=variable,group=variable)) + geom_smooth(size=1,method="loess",formula = y ~ x, se=FALSE)



# POSSIBLY USEFUL CODE ----------------------------------------------------

# Limits of list
length(issuelist)
length(issuelist[[2]])

# Select all tweets from current day in drange
tweets_curday <- tweets[tweets[, "created_at"] == drange[5], ]
# Is column a issue counting column?
str_detect(names(issues[2]), "^issue")